"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _graphql = require("gatsby/graphql");

var _commonFields = require("./commonFields");

var _cloudinaryPromised = require("cloudinary-promised");

var _getSrcSet = require("./getSrcSet");

var _getResponsiveWidths = require("./getResponsiveWidths");

var _commonTags = require("common-tags");

var _promise = _interopRequireDefault(require("md5-file/promise"));

var _getBase64FromUrl = require("./get-base64-from-url");

function _templateObject11() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n                    The max height the media will be displayed at.\n                    You probably want to use maxWidth instead of this.\n                "]);

  _templateObject11 = function _templateObject11() {
    return data;
  };

  return data;
}

function _templateObject10() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n                       A base64 version of the poster.\n                    "]);

  _templateObject10 = function _templateObject10() {
    return data;
  };

  return data;
}

function _templateObject9() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n                       srcSet for the poster.\n                    "]);

  _templateObject9 = function _templateObject9() {
    return data;
  };

  return data;
}

function _templateObject8() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n                       src for the poster.\n                    "]);

  _templateObject8 = function _templateObject8() {
    return data;
  };

  return data;
}

function _templateObject7() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n                       src for the video.\n                    "]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n                        A base64 version of the image.\n                    "]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n                        srcSet for the image (WebP).\n                    "]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n                        src for the image (WebP).\n                    "]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n                        srcSet for the image.\n                    "]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n                        src for the image.\n                    "]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n                        The aspect ratio of the media (width/height).\n                        Can be used to ensure there is space reserved for the media.\n                        This can prevent page jank when the media loads.\n                    "]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var _default = function _default(_ref) {
  var pathPrefix = _ref.pathPrefix,
      getNodeAndSavePathDependency = _ref.getNodeAndSavePathDependency,
      reporter = _ref.reporter,
      cloudinaryConfig = _ref.cloudinaryConfig;
  return {
    type: new _graphql.GraphQLObjectType({
      name: 'ImageCloudinaryFluid',
      fields: {
        width: {
          type: _graphql.GraphQLFloat,
          description: 'The original width of the media.'
        },
        height: {
          type: _graphql.GraphQLFloat,
          description: 'The original height of the media.'
        },
        aspectRatio: {
          type: _graphql.GraphQLFloat,
          description: (0, _commonTags.oneLine)(_templateObject())
        },
        // ----------------------------------------
        // img
        // ----------------------------------------
        imgSrc: {
          type: _graphql.GraphQLString,
          description: (0, _commonTags.oneLine)(_templateObject2())
        },
        imgSrcSet: {
          type: _graphql.GraphQLString,
          description: (0, _commonTags.oneLine)(_templateObject3())
        },
        imgWebPSrc: {
          type: _graphql.GraphQLString,
          description: (0, _commonTags.oneLine)(_templateObject4())
        },
        imgWebPSrcSet: {
          type: _graphql.GraphQLString,
          description: (0, _commonTags.oneLine)(_templateObject5())
        },
        imgBase64: {
          type: _graphql.GraphQLString,
          description: (0, _commonTags.oneLine)(_templateObject6())
        },
        // ----------------------------------------
        // video
        //
        // no srcSet or base64
        // as those do not make sense for videos
        // ----------------------------------------
        videoSrc: {
          type: _graphql.GraphQLString,
          description: (0, _commonTags.oneLine)(_templateObject7())
        },
        // ----------------------------------------
        // videoPoster
        // ----------------------------------------
        videoPosterSrc: {
          type: _graphql.GraphQLString,
          description: (0, _commonTags.oneLine)(_templateObject8())
        },
        videoPosterSrcSet: {
          type: _graphql.GraphQLString,
          description: (0, _commonTags.oneLine)(_templateObject9())
        },
        videoPosterBase64: {
          type: _graphql.GraphQLString,
          description: (0, _commonTags.oneLine)(_templateObject10())
        },
        sizes: {
          type: _graphql.GraphQLString
        }
      }
    }),
    args: {
      maxWidth: {
        type: _graphql.GraphQLInt,
        description: 'The max width the media will be displayed at.',
        defaultValue: 800
      },
      maxHeight: {
        type: _graphql.GraphQLInt,
        description: (0, _commonTags.oneLine)(_templateObject11())
      },
      toImgFormat: {
        type: _graphql.GraphQLString,
        description: 'Format to convert img to.'
      },
      toVideoFormat: {
        type: _graphql.GraphQLString,
        description: 'Format to convert video to.'
      },
      toVideoPosterFormat: {
        type: _graphql.GraphQLString,
        description: 'Format to convert videoPoster to.'
      }
    },
    resolve: function () {
      var _resolve = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(image, fieldArgs, context) {
        var file, path, id, data, width, maxWidth, presentationWidth, sizes, widths, mediaData, videoPosterSrc, videoSrc, videoSrcSetImages, videoPosterSrcSet, videoPosterBase64Url, videoPosterBase64, videoPosterData, videoData, format, imgBaseUrl, imgSrc, imgWebPSrc, imgSrcSetBaseUrls, imgSrcSetImages, imgSrcSet, imgWebPSrcSetImages, imgWebPSrcSet, imgBase64Url, imgBase64, imgData;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                file = getNodeAndSavePathDependency(image.parent, context.path);
                path = file.absolutePath; // Use an md5 hash of the file as the ID.

                _context.next = 4;
                return (0, _promise.default)(path);

              case 4:
                id = _context.sent;
                _context.next = 7;
                return (0, _cloudinaryPromised.uploadOrGetMetadata)(id, path, cloudinaryConfig);

              case 7:
                data = _context.sent;
                width = data.width;
                maxWidth = fieldArgs.maxWidth;
                presentationWidth = Math.min(width, maxWidth);
                sizes = "(max-width: ".concat(presentationWidth, "px) 100vw, ").concat(presentationWidth, "px");
                widths = (0, _getResponsiveWidths.getResponsiveWidths)(maxWidth, width);

                if (!(0, _cloudinaryPromised.isVideo)(path)) {
                  _context.next = 27;
                  break;
                }

                videoPosterSrc = "https://res.cloudinary.com/".concat(cloudinaryConfig.cloud_name, "/video/upload/w_").concat(width, "/").concat(id, ".jpg");
                videoSrc = "https://res.cloudinary.com/".concat(cloudinaryConfig.cloud_name, "/video/upload/w_").concat(width, "/").concat(id, ".mp4"); // Get the srcSet.

                videoSrcSetImages = widths.map(function (w) {
                  return {
                    width: w,
                    src: "https://res.cloudinary.com/".concat(cloudinaryConfig.cloud_name, "/video/upload/w_").concat(w, "/").concat(id, ".jpg")
                  };
                });
                videoPosterSrcSet = (0, _getSrcSet.getSrcSet)(videoSrcSetImages); // Get base64.

                videoPosterBase64Url = "https://res.cloudinary.com/".concat(cloudinaryConfig.cloud_name, "/video/upload/w_10/").concat(id, ".jpg");
                _context.next = 21;
                return (0, _getBase64FromUrl.getBase64FromUrl)(videoPosterBase64Url);

              case 21:
                videoPosterBase64 = _context.sent;
                videoPosterData = {
                  videoPosterSrc: videoPosterSrc,
                  videoPosterSrcSet: videoPosterSrcSet,
                  videoPosterBase64: videoPosterBase64
                };
                videoData = {
                  videoSrc: videoSrc
                };
                mediaData = (0, _objectSpread2.default)({}, videoPosterData, videoData);
                _context.next = 42;
                break;

              case 27:
                format = fieldArgs.toImgFormat || 'jpg'; // Get the src.

                imgBaseUrl = "https://res.cloudinary.com/".concat(cloudinaryConfig.cloud_name, "/image/upload/w_").concat(width, "/").concat(id);
                imgSrc = "".concat(imgBaseUrl, ".").concat(format);
                imgWebPSrc = "".concat(imgBaseUrl, ".webp"); // Get the srcSet.

                imgSrcSetBaseUrls = widths.map(function (w) {
                  return {
                    width: w,
                    src: "https://res.cloudinary.com/".concat(cloudinaryConfig.cloud_name, "/image/upload/w_").concat(w, "/").concat(id)
                  };
                }); // imgSrcSet

                imgSrcSetImages = imgSrcSetBaseUrls.map(function (v) {
                  return (0, _objectSpread2.default)({}, v, {
                    src: "".concat(v.src, ".").concat(format)
                  });
                });
                imgSrcSet = (0, _getSrcSet.getSrcSet)(imgSrcSetImages); // imgWebPSrcSet

                imgWebPSrcSetImages = imgSrcSetBaseUrls.map(function (v) {
                  return (0, _objectSpread2.default)({}, v, {
                    src: "".concat(v.src, ".webp")
                  });
                });
                imgWebPSrcSet = (0, _getSrcSet.getSrcSet)(imgWebPSrcSetImages); // Get base64.

                imgBase64Url = "https://res.cloudinary.com/".concat(cloudinaryConfig.cloud_name, "/image/upload/w_10/").concat(id, ".jpg");
                _context.next = 39;
                return (0, _getBase64FromUrl.getBase64FromUrl)(imgBase64Url);

              case 39:
                imgBase64 = _context.sent;
                imgData = {
                  imgSrc: imgSrc,
                  imgSrcSet: imgSrcSet,
                  imgWebPSrc: imgWebPSrc,
                  imgWebPSrcSet: imgWebPSrcSet,
                  imgBase64: imgBase64
                };
                mediaData = (0, _objectSpread2.default)({}, imgData);

              case 42:
                return _context.abrupt("return", (0, _objectSpread2.default)({
                  // internal
                  id: id,
                  path: path,
                  maxWidth: fieldArgs.maxWidth,
                  maxHeight: fieldArgs.maxHeight,
                  // dimensions
                  width: data.width,
                  height: data.height,
                  aspectRatio: data.width / data.height
                }, mediaData, {
                  sizes: sizes
                }));

              case 43:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function resolve(_x, _x2, _x3) {
        return _resolve.apply(this, arguments);
      };
    }()
  };
};

exports.default = _default;