"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _fsExtra = _interopRequireDefault(require("fs-extra"));

var _onNodeCreate = _interopRequireDefault(require("./on-node-create"));

var _extendNodeType = _interopRequireDefault(require("./extend-node-type"));

exports.onCreateNode = _onNodeCreate.default;
exports.setFieldsOnGraphQLNodeType = _extendNodeType.default; // Check if there are any ImageCloudinary nodes and if gatsby-image is installed. If so
// add fragments for ImageCloudinary and gatsby-image. The fragment will cause an error
// if there's not ImageCloudinary nodes and without gatsby-image, the fragment is useless.
// In the case there are no ImageCloudinary nodes then this function does nothing.

exports.onPreExtractQueries =
/*#__PURE__*/
function () {
  var _ref2 = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee(_ref) {
    var store, getNodes, program, nodes, gatsbyImageDoesNotExist;
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            store = _ref.store, getNodes = _ref.getNodes;
            program = store.getState().program;
            nodes = getNodes();

            if (nodes.some(function (n) {
              return n.internal.type === "ImageCloudinary";
            })) {
              _context.next = 5;
              break;
            }

            return _context.abrupt("return");

          case 5:
            gatsbyImageDoesNotExist = true;

            try {
              require.resolve("gatsby-image");

              gatsbyImageDoesNotExist = false;
            } catch (e) {// Ignore
            }

            if (!gatsbyImageDoesNotExist) {
              _context.next = 9;
              break;
            }

            return _context.abrupt("return");

          case 9:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x) {
    return _ref2.apply(this, arguments);
  };
}();