'use strict'

var _interopRequireDefault = require('@babel/runtime/helpers/interopRequireDefault')

Object.defineProperty(exports, '__esModule', {
    value: true,
})
exports.transform = exports.upload = void 0

var _promise = _interopRequireDefault(require('@babel/runtime/core-js/promise'))

var _cloudinary = _interopRequireDefault(require('./cloudinary'))

var upload = function upload(cloudinary) {
    return function(id, absolutePath) {
        return new _promise.default(function(resolve, reject) {
            return cloudinary.v2.uploader.upload(
                absolutePath,
                {
                    public_id: id,
                },
                function(error, result) {
                    if (error) reject(error)
                    resolve(result)
                },
            )
        })
    }
}

exports.upload = upload

var transform = function transform(cloudinary) {
    return function(id, options) {
        return new _promise.default(function(resolve, reject) {
            cloudinary.v2.uploader.explicit(
                id,
                {
                    type: 'upload',
                    eager: [options],
                },
                function(error, result) {
                    if (error) reject(error)
                    resolve(result)
                },
            )
        })
    }
}

exports.transform = transform
